/*----------------------------------------------------------------------------
 * Titel     : Minimalbeispiel fuer INSN-Fehler in GCC 4.8.1
 *----------------------------------------------------------------------------
 * Funktion  : - keine
 *
 * Schaltung : Rotorsteuergeraet fuer FTM25/6
 *----------------------------------------------------------------------------
 * Hardware  : AVR ATmega32
 * Takt      : 16 MHz
 * Sprache   : AVR-GCC
 * Datum     : 30.07.2015
 * Version   : -
 * Autor     : Nicolas
 *----------------------------------------------------------------------------*/

#ifndef MAIN_H
	#define MAIN_H

	#include <stdint.h>
	#include <avr/pgmspace.h>

	#define constflash const __flash

    typedef void (*voidFcn_t)(void);

	enum datatype_e {
		nothing,
		voidFcn,
		uint8,
		uint16,
		int8,
		int16
	};


	__extension__ typedef struct {
		constflash char *menutext; // Menueeintrag/Funktionsname
		enum datatype_e datatype;   // Datentyp des Zeigers "pointer"
		// Bei function pointer wird die Funktion
		// gestartet, bei Zeigern auf normale Daten
		// der Datentyp im Menue bearbeitet.
		union {
			voidFcn_t pvoidFcn;     // Funktionszeiger
			uint8_t  *puint8;       // Zeiger auf Variablentypen
			uint16_t *puint16;
			int8_t   *pint8;
			int16_t  *pint16;
			void     *pvoid;
		};
		const int16_t varMin;       // Untere Grenze numerische Variable
		const int16_t varMax;       // Oberere Grenze numerische Variable
	} menudata_t;                   // Struct wird terminiert mit einer Zeile,
									// wo in .menutext ein Nulltext
									// ({'\0'}) steht.
  
#endif // MAIN_H